const Calendar = imports.ui.calendar;
const Gio = imports.gi.Gio;
const GLib = imports.gi.GLib;

let _original;

var Urgency =
[
    "Low",
    "Normal",
    "High",
    "Critical"
];

function pathTest(path)
{
    if (!GLib.file_test(path, GLib.FileTest.IS_DIR))
        GLib.mkdir_with_parents(path, 0o755);
}

function getPath()
{
    return GLib.get_home_dir() + "/.notifications/";
}

function _onNotificationAdded(source, notification)
{
    _original.apply(this, [source, notification]);

    let path = getPath();

    let date = new Date();
    let filename = path + date.toISOString().slice(0,10);

    let file = Gio.file_new_for_path(filename);
    let fstream = file.append_to(Gio.FileCreateFlags.NONE, null);

    let datetime = notification.datetime.format("%H:%M:%S");
    let banners = source.policy.showBanners ? "Shown" : "Hidden";
    let urgency = Urgency[notification.urgency];
    let data = datetime + "|" + banners + "|" + urgency + "|" + notification.title + "|" + notification.bannerBodyText;
    data = data.replace("\\", "\\\\").replace("\n", "\\n") + "\n";
    fstream.write(data, null, data.length);

    fstream.close(null);
}

function init()
{
    _original = Calendar.NotificationSection.prototype._onNotificationAdded;
}

function enable()
{
    pathTest(getPath());

    Calendar.NotificationSection.prototype._onNotificationAdded = _onNotificationAdded;
}

function disable()
{
    Calendar.NotificationSection.prototype._onNotificationAdded = _original;
}
